/*
**	main.c
**
*/
#include "mpeg.h"
#include "disp.h"
#define SX 1280
#define SY 640
#define old
#define new
//#define End 1000
#define End 4096
#define Ending 2048

// select one of quarter or half or (none).
//#define quarter
#define half

// set color by rgbt able or calculate yuv value
#define SET_COLOR
// if you do not define, must use_yuv

// metalic ball expanding/shrink
#define Expand
// ellipse circle trace
//#define Circle

// Using yuv separate format or direct writing to rgb Ximage
//#define use_yuv
#ifdef old
#define R0 100
#define slow
#define CrossSize 8
#define CrossSiz2 8
#define floor1 0xC0C050
#define seili1 0xB080A0
#else
#define R0 128
#define CrossSize 7
#define CrossSiz2 9
#define floor1 0x90B080
#define seili1 0xA07080
#endif
#define bottom 0x001040
#define underf 0x005010
#define skyblu 0x3030FF
#define skywhi 0xF0F0F0
/*
up,cross2,cross, ref 
0   0   0	0: outside bottom
0   0   0	1: inside bottom
0   1	0	0: outside underfloor
0   1	0	1: inside underfloor
0   x	1	0: outside floor1
0   x	1	1: inside floor1
1   0   0	0: outside skyblue
1   0   0	1: inside skyblue
1   1	0	0: outside sky white
1   1	0	1: inside  sky white
1   x	1	0: outside seiling1
1   x	1	1: inside seiling1
*/
int mode;
int hight;
#ifdef use_yuv
struct sif { unsigned char y[SY][SX]; unsigned char c[2][SY/2][SX/2]; };
typedef struct	sif SIF;
SIF image;
#else
Uc *image=0;
#endif

int cmp,ddt,x2=1,vhs,bgc,wid,step,pause,sync=1;
double cur, startt, spent;
char name[99];

struct poi{ float x; float y; float z; };
typedef struct poi Pt;
Pt point(x,y,z) { Pt p; p.x= x; p.y= y; p.z= z; return p; }
float ip(p,q) Pt p,q; { float r; r= p.x*q.x+ p.y*q.y + p.z*q.z; return r; }
Pt padd(a,b) Pt a,b; { a.x+=b.x; a.y+=b.y; a.z+=b.z; return a; }
Pt psub(a,b) Pt a,b; { a.x-=b.x; a.y-=b.y; a.z-=b.z; return a; }
Pt smp(k,p) float k; Pt p; { p.x*= k; p.y*= k; p.z*= k; return p; }
Pt norm(p)  Pt p; { return smp((float)sqrt(1./(p.x*p.x +p.y*p.y +p.z*p.z)),p); }

float cos1= 0.5;
float sin1= 1.7320508/2.;
float cos2= 0.9659;
float sin2= 0.2588;

Pt rotate(p) Pt p;
{ 
    float t= p.x*cos1 -p.z*sin1;
	p.z= p.x*sin1 +p.z*cos1;
	p.x= t;
	  t= p.y*cos2 -p.z*sin2;
	p.z= p.y*sin2 +p.z*cos2;
	p.y= t;
	return p;
}

Pt op(a,v) Pt a,v;
{
	Pt r;
	r.x= a.y*v.z-a.z*v.y;
	r.y= a.z*v.x-a.x*v.z;
	r.z= a.x*v.y-a.y*v.x;
	return r;
}
float length2(r) Pt r; { return (float)(r.x*r.x+r.y*r.y+r.z*r.z); }
float distant2(a,v) Pt a,v; { return length2(op(a,v)); }

int rgb[16]= {
bottom, bottom, floor1, floor1,
underf, underf, floor1, floor1,//doubling of the upper line
skyblu, skyblu, seili1, seili1,
skywhi, skywhi, seili1, seili1, //doubling of the upper line
};
int Mode;
int  rgbt[16];
int yuv[16][3];
unsigned int *uidd;
clr(i,j,p,v,ref)
Pt p,v;
	{
	float t;
	int	ix,iz;
	int	luma,cb,cr;
	int	up,cross=0,cross2=0,cs,ts;
	int	ind;

	up= (v.y>0);
	t= (-SY/2+SY*up-p.y)/v.y;
	ix= v.x*t+ p.x;
	iz= v.z*t+ p.z;
	ix= ix>>(8+up);
	iz= iz>> CrossSize;

#ifndef new
	cross= (ix&1)==(iz&1);
#else
	//ts= (((iz+30)>>5)&255)>>2;
	ts= ((iz+30)>>5)&63;
	ix&=63; iz&=63;
	cs= ix^iz;
 	if(mode==0||Mode){
		Mode= 1;
		if(ts==0) mode= 0;
		else if(ts< 3) mode= 1;
		else if(ts<16) mode= 2;
		else if(ts<32) mode= 3;
		else if(ts<48) mode= 4;
		else if(ts<56) mode= 5;
		else if(ts<64) mode= 6;
	}
	if(mode==0) cross= cs= 0;			// 
	else if(mode==1) cross= cs==ts;			// islands
	else if(mode==2) cross= (ix<=ts&&(ix&1))^(iz<=ts&&(iz&1)); // lines
	else if(mode==3) cross= cs&1;			// old cross patch
	else if(mode==4) cross= cs&ts;			// landscapes
	else if(mode==5) cross= cs;			// colorful flags
	else if(mode==6) cross= cs > ts;		// focusing
#endif
	if(cross==0){
		t= (-SY*2+(SY*4)*up-p.y)/v.y;
		ix= v.x*t+ p.x;
		iz= v.z*t+ p.z;
		ix= ix>>(8+up);
		iz= iz>> CrossSiz2;
		cross2= ((ix&1)==(iz&1));
		}
#ifdef SET_COLOR
	ind= up*8+cross2*4+cross*2+ref;
#ifdef use_yuv
	image.y[j][i]= yuv[ind][0];
	if((i&1)==0&&(j&1)==0){
		image.c[0][j/2][i/2]= yuv[ind][1];
		image.c[1][j/2][i/2]= yuv[ind][2];
		}
#else
#ifdef quarter
		return rgbt[ind];
#else
#ifdef half
		return rgbt[ind];
#else
		*uidd++ =rgbt[ind];
#endif
#endif
#endif
#else
	luma= 60+cross2*80+cross*180;
	image.y[j][i]= luma;
	if((i&1)==0&&(j&1)==0){
		cb= 100+cross2*20+up*40;
		cr= 80+cross*25+ref*50;
		image.c[0][j/2][i/2]= cb;
		image.c[1][j/2][i/2]= cr;
		}
#endif
	}

lay(t0)
	{
	int	i,j;
	Pt eye,a,b;
	float c1,r0,r2;
	float t= t0;//+0.5*(j&1);
	int c,t1=t0;

#ifdef Expand
	while(t1>2*R0)t1-= 2*R0;
	r0= abs(t1-R0)+10; 
#else
	r0= R0;
#endif
	r2= r0*r0;

#ifdef Circle
	a= point((int)(-1000*sin(t*0.01))+750,-50,-(int)(200*cos(t*0.01))); 
	eye= smp(0.5, a);
#else
	t= t+t*t/4;
#ifdef slow
	t/=2;
#endif
	a= point(-500-(int)t,hight,(int)t); 
	if(t0>Ending) { int t= t0-Ending; a.y= (t*t)/100.; }
	eye= padd(a,smp(r2/2000.,point(270,50,-200)));
#endif
	b= psub(a,eye);
	c1= ip(b,b)-r2;

	uidd= (unsigned int*)dd;

#ifdef quarter
	for(j=3;j<SY;j+=2){
	for(c=i=1;i<SX;){
#else
#ifdef half
	for(j=0;j<SY;j++){
	for(c=i=1;i<SX;){
#else
	for(j=0;j<SY;j++){
	for(i=0;i<SX;i++){
#endif
#endif
		int	ref=0;
		int t, d, l, r, p, u, f, q, x;
		Pt p0= eye;
		Pt v= norm(rotate(point(i-SX/2, SY/2-j, SX)));
		if(distant2(b,v)< r2) {
			float b1,k;
			Pt p1;
			b1= ip(b,v);
			p1= padd( eye, smp(b1-sqrt(b1*b1-c1), v) );
			k= -2.*ip(v,psub(p1,a))/r2;
			v= padd( v, smp( k, psub(p1,a) ) );
			p0= p1;
			ref= 1;
			}
#ifdef quarter
		x= SX*j+i; uidd[x]= t= clr(i,j,p0,v,ref);
		if(!(i&1)&&!(j&1)) { i+=3; j++; }
		else if(!(i&1)) { l= t; i++; goto lab1; }
		else if(!(j&1)) { r= t; j++; goto lab2; }
		else {
			d= t;
			if(c==d) l= uidd[x-1]= d;
			else if(uidd[x-SX-2]==t) l= uidd[x-1]= t;	// left
			else { i--; continue; }
		lab1:
			x= SX*(j-2)+i; q= uidd[x-1]; u= uidd[x];// upline: f,q,u
			if(u==d) r= uidd[x+SX]= d;		// midline:p   r
			else if(q==d) r= uidd[x+SX]= d;		// curline:c,l,d
			else { j--; continue; }	
		lab2:
			x= SX*(j-2)+i-1;
			     if(u==c) uidd[x+SX]= c;
			else if(r==c) uidd[x+SX]= c;
			else if(q==c) uidd[x+SX]= c;
			else if(q==l) uidd[x+SX]= l;
			else if(q==d) uidd[x+SX]= d;	
			else if(p==d) uidd[x+SX]= d;	
			else if(f==d) uidd[x+SX]= d;	
			else if(f==r) uidd[x+SX]= f;	
			else if(f==l) uidd[x+SX]= f;	
			else if(l==u) uidd[x+SX]= l;
			else if(p==r) uidd[x+SX]= r;
			else if(p==u) uidd[x+SX]= p;
			else { i--; j--; continue; }
			c= d; p= r; f= u;
			i+=2;
		}
#else
#ifdef half
		uidd[SX*j+i]= t= clr(i,j,p0,v,ref);
		if((i&1)==0) i+=3;
		else if(c==t){ uidd[SX*j+i-1]= t; i+=2; }
		else { c= t; i--; }
#else
		clr(i,j,p0,v,ref);
#endif
#endif
		}}
	}

set_color(){
	int i;
#ifdef use_yuv
	for(i=0;i<16;i++){
		float r,g,b,y,cb,cr;
		r= (rgb[i]>>16)&255;
		g= (rgb[i]>>8)&255;
		b= (rgb[i])&255;
		r/= 255.;
		g/= 255.;
		b/= 255.;
		y= 0.299*r+0.587*g+0.114*b;
		cb= 0.564*(b-y);
		cr= 0.713*(r-y);
		yuv[i][0]= (int)(y*219+16);
		yuv[i][1]= (int)(cb*224+128);
		yuv[i][2]= (int)(cr*224+128);
	}
#else
extern Visual *vis;
	int rm,gm,bm;
	int rs,gs,bs;
	rm= vis->red_mask;
	gm= vis->green_mask;
	bm= vis->blue_mask;
	for(i=0;i<32;i++) if((rm <<i)&0x80000000)break; rs= i;
	for(i=0;i<32;i++) if((gm <<i)&0x80000000)break; gs= i;
	for(i=0;i<32;i++) if((bm <<i)&0x80000000)break; bs= i;
	for(i=0;i<16;i++){
		Ui r,g,b;
		r= ((rgb[i]>>16)&255)<<24;
		g= ((rgb[i]>>8)&255)<<24;
		b= ((rgb[i])&255)<<24;
                rgbt[i]= ((r>>rs)&rm)|((g>>gs)&gm)|((b>>bs)&bm);
	}
#endif
}

main(argc, argv) int argc; char	**argv; {
	int i;
	if(argc>2){ fprintf(stderr,"Usage: %s mode(0-10) (-mode is highview) \n",argv[0]); exit(1); }
	if(argc==1) mode= 0;
	else
	mode= atoi(argv[1]);
	if(mode<0) {
		mode= -mode;
		hight= 1000;
	} else  hight= -100;
	iwt(argv[0],&image,SX,SY);
	set_color();
	for(i=0;i<End;i++){
		lay(i);
		sprintf(name,"%s%0d",argv[0],i);
		wt(name,&image,
#ifdef use_yuv
		1
#else
		0
#endif
		);
		if(pause){ i--; if(step) { i+=step; step= 0;} usleep(100000); }
		}
	}
